{# form

Handle an input form. A single form can be divided in more then one widget with
the same ID, so the form can be inserted into other widgets such as accordions
or tabbed. The tag <form> is opened if widget has the field "action" and is
automatically closed with tag </form> but if the widget field "opened" is true
the form remain opened until another form widget hasn't the field "opened"

parameters:
  id: give a unique ID to every widget in the page
  style: additional css style rules for this ID
  class: set additional classes for the widget
  action: action to perform, if not present, no tag <form> is opened
  target: target of action
  method: can be post or get
  opened: if true no tag </form> is closed
  input: list of input fields of the form
  - type: type of input, same as html documentation plus "html" thet has a
      special meaning, let you to add some free html within the form.
    id: unique id within the form
    column: number of columns for the row from 1 to 12 handled by bootstrap
    label: Label for input field
    value: initial value for the field
    pattern: regular expression for browser level validation.
      Try '[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$' for email validation.
    placeholder: placeholder for the field
    attr: can be "required" or/and "disabled"
    group_before: handled by bootstrap, let to compose a input group
    group_after: handled by bootstrap, let to compose a input group
    inline: only for checkbox and radio, let to handle inline series of controls
    ckh_items: items for checkbox and radio. Each item has: 0=id,
      1=text for checkbox, 2=attributes checked, disabled, required, 3=class
    options: only for select the list of options
    selected: only for select set the selected option.
    min, max, step: options for "range" input.
-#}
{%include "include/widget_style.html" -%}
{#- Open the form only if action is present -#}
{% if widget.action -%}
<form id="{{widget.id}}" action="{{widget.action}}" method="{{widget.method}}" target="{{widget.target}}">
{% endif -%}
  {% if widget.input -%}<div class="row {{widget.class}}">{% endif -%}
    {% for fld in widget.input -%}
    <div class="col-md-{{fld.column or 12}}">
      {% if fld.type == 'html' -%}
      <div class="{{fld.class}} style=" {{fld.style}} id="{{widget.id}}-{{fld.id}}">
        {{fld.text}}
      </div>
      {% elif fld.type == 'select' -%}
      <label for="{{widget.id}}-{{fld.id}}" class="form-label">{{fld.label}}</label>
      <select id="{{widget.id}}-{{fld.id}}" class="form-select {{fld.class}}" placeholder="{{fld.placeholder}} {{fld.attr}}">
        {% for option in fld.options -%}
        <option {{option if option==fld.selected else '' }}>{{option}}</option>
        {% endfor %}
      </select>
      {% elif fld.type == 'range' -%}
      <label for="{{widget.id}}-{{fld.id}}" class="form-label">{{fld.label}}</label>
      <input type="{{fld.type}}" class="form-range" min="{{fld.min}}" max="{{fld.max}}" step="{{fld.step}}" value="{{fld.value}}" id="{{widget.id}}-{{fld.id}}">
      {% elif fld.type in ['radio', 'checkbox'] -%}
      {% for item in fld.ckh_items -%}
      <div class="form-check{{'-inline' if fld.inline else ''}} {{item[3] or ''}}">
        <input class="form-check-input" type="{{fld.type}}" name="{{widget.id}}-{{fld.id}}-{{item[0]}}" id="{{widget.id}}-{{fld.id}}-{{item[0]}}" {{item[2]}}>
        <label class="form-check-label" for="{{widget.id}}-{{fld.id}}-{{item[0]}}">{{item[1]}}</label>
      </div>
      {% endfor -%}
      {% elif fld.type == 'submit' -%}
      <button type="{{fld.type}}" class="{{fld.class}}">{{fld.value}}</button>
      {% else -%}
      <label for="{{widget.id}}-{{fld.id}}" class="form-label">{{fld.label}}</label>
      {% if fld.group_before or fld.group_after %}<div class="input-group">{% endif -%}
      {% if fld.group_before %}<span class="input-group-text">{{fld.group_before}}</span>{% endif -%}
      {% if fld.type=="textarea" %}
      <textarea class="form-control {{fld.class}}" id="{{widget.id}}-{{fld.id}}" rows="{{fld.rows}}" name="{{widget.id}}-{{fld.id}}" placeholder="{{fld.placeholder}}" value="{{fld.value}}" {{fld.attr}}></textarea>
      {% else -%}
      <input type="{{fld.type}}" class="form-control {{fld.class}}" id="{{widget.id}}-{{fld.id}}" name="{{widget.id}}-{{fld.id}}" placeholder="{{fld.placeholder}}" value="{{fld.value}}" {{fld.attr}} {%if fld.pattern%} pattern="{{fld.pattern}}" {%endif%}>
      {% endif -%}
      {% if fld.group_after %}<span class="input-group-text">{{fld.group_after}}</span>{% endif -%}
      {% if fld.group_before or fld.group_after %}</div>{% endif -%}
      {% endif -%}
    </div>
    {% endfor -%}
  {% if widget.input -%}</div>{% endif -%}
{% if not widget.opened -%}
</form>
{% endif -%}
